# generated by datamodel-codegen:
#   filename:  experts-portal-money.json

from __future__ import annotations

from typing import Literal, Sequence

from pydantic import BaseModel, ConfigDict, SerializeAsAny


class CalculateAmountRequestDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    payment_system: Literal['FLUTTERWAVE', 'ONTOP', 'PAPARA', 'PAYONEER', 'SOLAR', 'FILE']
    amount: float


class CalculatedWithdrawalAmountsDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    currency: Literal['USD', 'EUR', 'RUB', 'GHS', 'KES', 'UGX', 'TZS', 'RWF', 'ZMW', 'XAF', 'XOF']
    withdrawal_amount: float
    fee_amount: float
    result_amount: float


class TransactionSummaryDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    success: int | None = None
    fail: int | None = None
    no_money: int | None = None


class FlutterwaveSuggestedAccountDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    countryCode: (
        Literal[
            'AB',
            'OS',
            'AD',
            'AE',
            'AF',
            'AG',
            'AI',
            'AL',
            'AM',
            'AO',
            'AQ',
            'AR',
            'AT',
            'AU',
            'AW',
            'AZ',
            'BA',
            'BB',
            'BD',
            'BE',
            'BF',
            'BG',
            'BH',
            'BI',
            'BJ',
            'BM',
            'BN',
            'BO',
            'BR',
            'BS',
            'BT',
            'BW',
            'BY',
            'BZ',
            'CA',
            'CC',
            'CD',
            'CF',
            'CG',
            'CH',
            'CI',
            'CK',
            'CL',
            'CM',
            'CN',
            'CO',
            'CR',
            'CU',
            'CV',
            'CW',
            'CY',
            'CZ',
            'DE',
            'DJ',
            'DK',
            'DM',
            'DO',
            'DZ',
            'EC',
            'EE',
            'EG',
            'EH',
            'ER',
            'ES',
            'ET',
            'FI',
            'FJ',
            'FK',
            'FM',
            'FR',
            'GA',
            'GB',
            'GD',
            'GE',
            'GF',
            'GH',
            'GI',
            'GL',
            'GM',
            'GN',
            'GP',
            'GQ',
            'GR',
            'GS',
            'GT',
            'GU',
            'GW',
            'GY',
            'HN',
            'HR',
            'HT',
            'HU',
            'ID',
            'IE',
            'IL',
            'IN',
            'IQ',
            'IR',
            'IS',
            'IT',
            'JM',
            'JO',
            'JP',
            'KE',
            'KG',
            'KH',
            'KI',
            'KM',
            'KN',
            'KP',
            'KR',
            'KW',
            'KY',
            'KZ',
            'LA',
            'LB',
            'LC',
            'LI',
            'LK',
            'LR',
            'LS',
            'LT',
            'LU',
            'LV',
            'LY',
            'MA',
            'MC',
            'MD',
            'ME',
            'MG',
            'MH',
            'MK',
            'ML',
            'MM',
            'MN',
            'MP',
            'MQ',
            'MR',
            'MS',
            'MT',
            'MU',
            'MV',
            'MW',
            'MX',
            'MY',
            'MZ',
            'NA',
            'NC',
            'NE',
            'NF',
            'NG',
            'NI',
            'NL',
            'NO',
            'NP',
            'NR',
            'NU',
            'NZ',
            'OM',
            'PA',
            'PE',
            'PF',
            'PG',
            'PH',
            'PK',
            'PL',
            'PR',
            'PS',
            'PT',
            'PW',
            'PY',
            'QA',
            'RE',
            'RO',
            'RS',
            'RU',
            'RW',
            'SA',
            'SB',
            'SC',
            'SD',
            'SE',
            'SG',
            'SI',
            'SK',
            'SL',
            'SM',
            'SN',
            'SO',
            'SR',
            'SS',
            'ST',
            'SV',
            'SX',
            'SY',
            'SZ',
            'TC',
            'TD',
            'TG',
            'TH',
            'TJ',
            'TK',
            'TL',
            'TM',
            'TN',
            'TO',
            'TR',
            'TT',
            'TV',
            'TW',
            'TZ',
            'UA',
            'UG',
            'US',
            'UY',
            'UZ',
            'VA',
            'VC',
            'VE',
            'VG',
            'VI',
            'VN',
            'VU',
            'WS',
            'YE',
            'YT',
            'ZA',
            'ZM',
            'ZW',
            'AN',
            'AS',
            'AX',
            'BL',
            'BQ',
            'BV',
            'CS',
            'CX',
            'FO',
            'GG',
            'HK',
            'HM',
            'IM',
            'IO',
            'JE',
            'MF',
            'MO',
            'PM',
            'PN',
            'SH',
            'SJ',
            'TF',
            'UM',
            'WF',
        ]
        | None
    ) = None
    countryCallingCode: str | None = None
    currencyCode: Literal['USD', 'EUR', 'RUB', 'GHS', 'KES', 'UGX', 'TZS', 'RWF', 'ZMW', 'XAF', 'XOF'] | None = None
    exchangeRate: float | None = None
    feeDescription: str | None = None
    availableMoneyOperators: (
        Sequence[
            Literal[
                'MPS',
                'MPX',
                'MTN',
                'TIGO',
                'VODAFONE',
                'AIRTEL',
                'FMM',
                'ORANGEMONEY',
                'EMONEY',
                'FREEMONEY',
            ]
        ]
        | None
    ) = None


class FilePaymentSystemDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    code: str | None = None
    is_admin_manageable_transactions: bool | None = None


class FilePaymentSystemDtoResponse(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    data: Sequence[FilePaymentSystemDto] | None = None


class CalculateAmountResponseDto(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    source_amounts: CalculatedWithdrawalAmountsDto
    destination_amounts: CalculatedWithdrawalAmountsDto
