# generated by datamodel-codegen:
#   filename:  experts-portal-qualification.json

from __future__ import annotations

from typing import Any, Literal, Mapping, Sequence

from pydantic import BaseModel, ConfigDict, SerializeAsAny

from .action import Action, OnIdleAction
from .criteria import Criteria


class StepContext(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    type: (
        Literal[
            'TOLOKA_TASK',
            'INFORMER',
            'QUALIFICATION_EXERCISE',
            'QUALIFICATION_PIPELINE',
        ]
        | None
    ) = None


class StepEdge(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    next_step_id: str | None = None
    terminal_status: Literal['ACTIVE', 'FINISHED', 'FAILED'] | None = None
    actions: Sequence[Action] | None = None


class StepOnIdle(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    actions: Sequence[OnIdleAction] | None = None


class StepConfig(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    step_id: str
    step_name: str | None = None
    pass_criteria: Criteria | None = None
    fail_criteria: Criteria | None = None
    skip_criteria: Criteria | None = None
    on_pass: StepEdge | None = None
    on_fail: StepEdge | None = None
    on_idle: StepOnIdle | None = None
    informer: Mapping[str, Any] | SerializeAsAny[BaseModel] | None = None
    context: StepContext
